# -*- coding: utf-8 -*-
#    original ml-10-01-iris-deep-learn.py
#    reference aidiary.hatenablog.com/entry/20161108/1478609028
#   modified by Masayuki Kogoshi & Sumio Kogoshi
#    (for prediction)
#***************************************************************
import keras
from keras.models import model_from_json
from keras.utils import np_utils
from sklearn.preprocessing import StandardScaler
import numpy as np
import matplotlib.pyplot as plt
import sys
import pandas as pd
from pandas import DataFrame

# 学習済AIモデルの読み込み
model_arc_str = open("model_architecture.json").read()
model = model_from_json(model_arc_str)
model.load_weights("weights.hdf5")

# アヤメのデータをロードし、変数iris_dataに格納
iris_data = pd.read_csv("iris_test.csv",sep=",",header=0)

# 特徴量のセットを変数Xに、ターゲットを変数yに格納
X = DataFrame(iris_data.drop("class",axis=1))
y1 = DataFrame(iris_data["class"])
y2 = np.array(y1.T)
y = y2[0]

#standardization of x data　アヤメの分類では不用かも
scaler = StandardScaler()
scaler.fit(X)
X = scaler.transform(X)

# サンプル数、特徴量の次元、クラス数の取り出し
(n_samples, n_features) = X.shape
n_classes = 3

# ターゲットyをkeras用の形式に変換
y_keras = np_utils.to_categorical(y, n_classes)

#予測
result1 = model.predict(X)
result = np.argmax(result1,axis=1)

# 結果の表示
print('ターゲット')
print(y)
print('ディープラーニングによる予測')
print(result)

# データ数をtotalに格納
total = len(X)
# ターゲット（正解）と予測が一致した数をsuccessに格納
success = sum(result==y)

# 正解率をパーセント表示
print('正解率')
print(100.0*success/total)

